#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

const int CSIZE = 6*1024*1024;
unsigned char Data[CSIZE]; 

int main(int argc, char * argv[])
{
  int    i, j, n, c, size, xres, yres, bpp;
  char    szImage[] = "img000.tga";
  FILE   * f1;
  FILE   * f2;

  if ((f1 = fopen("D2N_rs.bin", "rb")) != 0) 
  {
    size = fread(&Data, 1, CSIZE, f1);
    fclose(f1);
  }
  else
  {
    printf( "ERROR: D2N_rs.bin not found\n" );
    return 1;
  }

  c = 0;
  n = 0;

  while (c+4<size)
  {
    bpp = 1;
    if (Data[c] == 16)
    {
      bpp = 2;
    }
    else
    if ((Data[c] >= 24) && (Data[c] <= 32))
    {
      bpp = 4;
    }
    xres = Data[c+1] + (Data[c+2] << 8);
    yres = Data[c+3] + (Data[c+4] << 8);

    if ((bpp == 1) || (xres == 0) || (xres > 320) || (yres == 0) || (yres > 240))
    {
      c++;
    }
    else
    {
      unsigned short TGAheader[9] = {0,2,0,0,0,0,xres,yres,2080};
      unsigned int   p0, p1, r, g, b, a, col;

      szImage[3] = '0'+((n/100)%10);
      szImage[4] = '0'+((n/10)%10);
      szImage[5] = '0'+(n%10);

      printf( "0x%6X: %s  [%dx%d] (%d bit)\n", c, szImage, xres, yres, Data[c] );

      if ((f2 = fopen(szImage, "wb")) != 0) 
      {
        fwrite(&TGAheader, sizeof(TGAheader), 1, f2);
        if (bpp == 2)
        {
          for (j=0; j<yres; j++)
          for (i=0; i<xres; i++)
          {
            p0 = Data[c+5+(yres-1-j)*xres*2+i*2];
            p1 = Data[c+5+(yres-1-j)*xres*2+i*2+1];
           
			r  = (p1 & 0xF8);
			g  = ((p1 & 0x07) << 5) + ((p0 & 0xE0) >> 3);
			b  = (p0 & 0x1F) << 3;
			a = 0xFF;
			if( g == 0xFC && r==0 && b==0)
				a = 0;
	
            col =  (a<<24) + (r<<16) + (g<<8) + b;

            fwrite(&col, 4, 1, f2);
          }
        }
        else
        {
          for (j=0; j<yres; j++)
		  {
            fwrite(&Data[c+5+(yres-1-j)*xres*4], xres*4, 1, f2);
		  }
        }
        fclose(f2);
      }
      c += xres*yres*bpp+5;
      n++;
    }
  }
  printf("\nOK\n");

  return 0;
}
