#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

const int CSIZE = 4194304;
unsigned char Data[CSIZE]; 
unsigned char Image[400000];

int main(int argc, char * argv[])
{
  int    i, j, n, c, size, xres, yres, bpp, res;
  int    num_good = 0;
  int    num_bad  = 0;
  char   * szImage = "img000.tga";
  FILE   * f1;
  FILE   * f2;

  if ((f1 = fopen("D2N_rs.bin", "rb")) != 0) 
  {
    size = fread(&Data, 1, CSIZE, f1);
    fclose(f1);
  }
  else
  {
    printf( "ERROR: D2N_rs.bin not found\n" );
    return 1;
  }

  c = 0;
  n = 0;

  f1 = fopen("D2N_rs.bin", "rb+");

  while (c+4<size)
  {
    bpp = 1;
    if (Data[c] == 16)
    {
      bpp = 2;
    }
    else
    if ((Data[c] >= 24) && (Data[c] <= 32))
    {
      bpp = 4;
    }
    xres = Data[c+1] + (Data[c+2] << 8);
    yres = Data[c+3] + (Data[c+4] << 8);

    if ((bpp == 1) || (xres == 0) || (xres > 320) || (yres == 0) || (yres > 240))
    {
      c++;
    }
    else
    {
      unsigned short TGAheader[9];
      unsigned int   r, g, b, a, col;

      szImage[3] = '0'+((n/100)%10);
      szImage[4] = '0'+((n/10)%10);
      szImage[5] = '0'+(n%10);

      if ((f2 = fopen(szImage, "rb")) != 0) 
      {
        res = 0;
        printf( "loading %s ...", szImage );
        if (fread(&TGAheader, sizeof(TGAheader), 1, f2) == 1)
        {
          if ((TGAheader[0] == 0) && (TGAheader[1] == 2) && (TGAheader[2] == 0) && (TGAheader[3] == 0))
          {
            if ((TGAheader[6] == xres) && (TGAheader[7] == yres) && ((TGAheader[8] & 0xFF) >= 24))
            {
              unsigned int tga_bpp = (TGAheader[8] & 0xFF)/8;
              unsigned int tga_size = xres*yres*tga_bpp;

              if ( fread(&Image, 1, tga_size, f2) == tga_size)
              {
                fseek( f1, c+5, SEEK_SET );

                if (tga_bpp == 4)
                {
                  if (bpp == 4)
                  {
                    for (j=0; j<yres; j++)
                      fwrite(&Image[(yres-1-j)*xres*4], xres*4, 1, f1);
                  }
                  else
                  {
                    for (j=0; j<yres; j++)
                    for (i=0; i<xres; i++)
                    {
                      b = Image[(yres-1-j)*xres*4+i*4] >> 3;
                      g = Image[(yres-1-j)*xres*4+i*4+1] >> 2;
                      r = Image[(yres-1-j)*xres*4+i*4+2] >> 3;
                      col = (r<<11) + (g<<5) + b;
                      fwrite(&col, 2, 1, f1);
                    }
                  }
                }
                else
                {
                  for (j=0; j<yres; j++)
                  for (i=0; i<xres; i++)
                  {
                    b  = Image[(yres-1-j)*xres*3+i*3];
                    g  = Image[(yres-1-j)*xres*3+i*3+1];
                    r  = Image[(yres-1-j)*xres*3+i*3+2];

                    if (bpp == 4)
                    {
                      a  = Data[c+5+j*xres*4+i*4+3];
                      col = (a<<24) +(r<<16) + (g<<8) + b;
                      fwrite(&col, 4, 1, f1);
                    }
                    else
                    {
                      col = ((r>>3)<<11) + ((g>>2)<<5) + (b>>3);
                      fwrite(&col, 2, 1, f1);
                    }
                  }
                }
                res = 1;
                printf( "successful\n" );
              }
              else
                printf( "error 4\n" );
            }
            else
              printf( "error 3\n" );
          }
          else
            printf( "error 2\n" );
        }
        else
          printf( "error 1\n" );

        if ( res == 1 )
          num_good++;
        else
          num_bad++;
      }
      c += xres*yres*bpp+5;
      n++;
    }
  }

  fclose(f1);

  if (num_bad == 0)
    printf("\nAll OK\n");
  else
    printf("\n%3d images: successful\n%3d images: failed\n", num_good, num_bad);

  return 0;
}
